## libzeep 6.1.1

=== CMakeLists.txt ===
# Copyright Maarten L. Hekkelman, 2023
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.22)

project(libzeep VERSION 6.1.0 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(FindFilesystem)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
include(VersionString)
include(CTest)
include(CMakeDependentOption)

option(ZEEP_BUILD_LIBRARY "Build the library from source code, should be off when configuring on ReadTheDocs" ON)
option(ZEEP_BUILD_DOCUMENTATION "Build documentation" OFF)
option(ZEEP_USE_BOOST_ASIO "Use the asio library from Boost instead of the non-boost version" ON)
option(ZEEP_ALLOW_FETCH_CONTENT "Use cmake's FetchContent to retrieve missing packages" ON)
cmake_dependent_option(ZEEP_BUILD_EXAMPLES "Build the example applications" ON "ZEEP_BUILD_LIBRARY" OFF)

# New policy for Boost, set it here
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.30)
	cmake_policy(SET CMP0167 NEW)
endif()

if(ZEEP_BUILD_LIBRARY)
	set(CXX_EXTENSIONS OFF)
	set(CMAKE_CXX_STANDARD 20)
	set(CMAKE_CXX_STANDARD_REQUIRED ON)

	# When building with ninja-multiconfig, build both debug and release by default
	if(CMAKE_GENERATOR STREQUAL "Ninja Multi-Config")
		set(CMAKE_CROSS_CONFIGS "Debug;Release")
		set(CMAKE_DEFAULT_CONFIGS "Debug;Release")
	endif()

	find_package(Filesystem REQUIRED)

	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter")
	elseif(MSVC)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
	endif()

	# Build shared libraries by default (not my cup of tea, but hey)
	option(BUILD_SHARED_LIBS "Build a shared library instead of a static one" OFF)
	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

	if(WIN32)
		if(${CMAKE_SYSTEM_VERSION} GREATER_EQUAL 10) # Windows 10
			add_definitions(-D _WIN32_WINNT=0x0A00)
		elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
			add_definitions(-D _WIN32_WINNT=0x0603)
		elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
			add_definitions(-D _WIN32_WINNT=0x0602)
		elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
			add_definitions(-D _WIN32_WINNT=0x0601)
		elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
			add_definitions(-D _WIN32_WINNT=0x0600)
		else() # Windows XP (5.1)
			add_definitions(-D _WIN32_WINNT=0x0501)
		endif()

		add_definitions(-DNOMINMAX)
	endif()

	if(MSVC)
		# make msvc standards compliant...
		add_compile_options(/permissive-)
	endif()

	# Optionally use mrc to create resources
	if(WIN32 AND BUILD_SHARED_LIBS)
		message("Not using resources when building shared libraries for Windows")
	else()
		find_package(Mrc QUIET)

		if(MRC_FOUND)
			option(USE_RSRC "Use mrc to create resources" ON)

			if(USE_RSRC)
				message("Using resources compiled with ${MRC_EXECUTABLE} version ${MRC_VERSION_STRING}")
				set(WEBAPP_USES_RESOURCES 1)
			endif()
		else()
			message(STATUS "Not using resources since mrc was not found")
		endif()
	endif()

	set(CMAKE_THREAD_PREFER_PTHREAD)
	set(THREADS_PREFER_PTHREAD_FLAG)
	find_package(Threads REQUIRED)

	if(ZEEP_USE_BOOST_ASIO)
		find_package(Boost 1.74 REQUIRED)

		message(STATUS "Using asio from boost")

		configure_file(${PROJECT_SOURCE_DIR}/cmake/asio-boost.hpp.in ${PROJECT_SOURCE_DIR}/include/zeep/http/asio.hpp @ONLY)

		set(FIND_DEPENDENCY_BOOST "find_dependency(Boost REQUIRED)")
	else()
		find_path(ASIO_INCLUDE_DIR asio.hpp REQUIRED)
		message(STATUS "Using standalone asio")
		configure_file(${PROJECT_SOURCE_DIR}/cmake/asio.hpp.in ${PROJECT_SOURCE_DIR}/include/zeep/http/asio.hpp @ONLY)
	endif()

	if(NOT (TARGET date OR date_FOUND))
		find_package(date 3.0.1 QUIET NAMES date libhowardhinnant-date)

		if(NOT date_FOUND)
			if(ZEEP_ALLOW_FETCH_CONTENT)
				include(FetchContent)

				FetchContent_Declare(date GIT_REPOSITORY https://github.com/HowardHinnant/date.git GIT_TAG v3.0.1)
				FetchContent_MakeAvailable(date)
			else()
				message(FATAL_ERROR "The date package was not found, please install https://github.com/HowardHinnant/date and try again")
			endif()
		endif()
	endif()

	if(UNIX)
		set(HTTP_HAS_UNIX_DAEMON 1)

		find_file(HAVE_SYS_WAIT_H "sys/wait.h")

		if(HAVE_SYS_WAIT_H)
			set(HTTP_SERVER_HAS_PREFORK 1)
		endif()
	endif()

	# Generate the revision.hpp file
	write_version_header("${PROJECT_SOURCE_DIR}/lib-xml/src" LIB_NAME "libzeep")

	list(APPEND ZEEP_HEADERS
		${PROJECT_SOURCE_DIR}/include/zeep/crypto.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/streambuf.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/value-serializer.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/config.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/xml/document.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/xml/parser.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/xml/xpath.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/xml/node.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/xml/character-classification.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/xml/serialize.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/xml/doctype.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/type-traits.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/to_element.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/element.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/factory.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/serializer.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/parser.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/type_traits.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/from_element.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/element_fwd.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/json/iterator.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/asio.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/access-control.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/controller.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/message-parser.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/tag-processor.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/connection.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/server.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/daemon.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/error-handler.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/reply.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/template-processor.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/header.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/request.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/rest-controller.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/soap-controller.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/html-controller.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/security.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/uri.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/el-processing.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/http/login-controller.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/unicode-support.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/nvp.hpp
		${PROJECT_SOURCE_DIR}/include/zeep/exception.hpp
	)

	list(APPEND ZEEP_SRC
		${PROJECT_SOURCE_DIR}/lib-http/src/access-control.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/connection.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/controller.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/crypto.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/daemon.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/el-processing.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/error-handler.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/format.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/glob.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/html-controller.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/login-controller.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/message-parser.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/reply.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/request.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/rest-controller.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/security.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/server.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/uri.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/soap-controller.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/tag-processor-v2.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/tag-processor.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/template-processor.cpp
		${PROJECT_SOURCE_DIR}/lib-http/src/signals.cpp
		${PROJECT_SOURCE_DIR}/lib-json/src/element.cpp
		${PROJECT_SOURCE_DIR}/lib-json/src/json-parser.cpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/character-classification.cpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/doctype.cpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/document.cpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/html-named-characters.hpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/html-named-characters.cpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/node.cpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/xml-parser.cpp
		${PROJECT_SOURCE_DIR}/lib-xml/src/xpath.cpp
	)

	if(USE_RSRC)
		list(APPEND ZEEP_SRC
			${PROJECT_SOURCE_DIR}/lib-http/src/controller-rsrc.cpp)
	endif()

	if(HTTP_SERVER_HAS_PREFORK)
		list(APPEND ZEEP_HEADERS ${PROJECT_SOURCE_DIR}/include/zeep/http/preforked-server.hpp)
		list(APPEND ZEEP_SRC ${PROJECT_SOURCE_DIR}/lib-http/src/preforked-server.cpp)
	endif()

	add_library(zeep ${ZEEP_SRC} ${ZEEP_HEADERS})
	add_library(zeep::zeep ALIAS zeep)
	set_target_properties(zeep PROPERTIES POSITION_INDEPENDENT_CODE ON)

	target_include_directories(zeep
		PUBLIC
		"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include;${ASIO_INCLUDE_DIR}>"
		"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
	)

	target_link_libraries(zeep PUBLIC Threads::Threads date::date ${STDCPPFS_LIBRARY})

	if(ZEEP_USE_BOOST_ASIO)
		target_link_libraries(zeep PUBLIC Boost::boost)
	endif()

	if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
		target_link_options(zeep PRIVATE -undefined dynamic_lookup)
	endif()

	# # Build debug library with d postfix
	# set(CMAKE_DEBUG_POSTFIX d)
	# set_target_properties(zeep PROPERTIES DEBUG_POSTFIX "d")

	# Install rules
	install(TARGETS zeep
		EXPORT zeep-targets
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

	install(EXPORT zeep-targets
		NAMESPACE zeep::
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/zeep
	)

	install(
		DIRECTORY include/zeep
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
		COMPONENT Devel
		PATTERN "config.hpp.in" EXCLUDE
	)

	configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/zeep-config.cmake.in
		${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config.cmake
		INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/zeep
	)

	write_basic_package_version_file(
		"${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config-version.cmake"
		COMPATIBILITY AnyNewerVersion
	)

	file(GLOB OLD_CONFIG_FILES
		${CMAKE_INSTALL_FULL_LIBDIR}/cmake/zeep/zeepConfig*.cmake
		${CMAKE_INSTALL_FULL_LIBDIR}/cmake/zeep/zeepTargets*.cmake)

	if(OLD_CONFIG_FILES)
		message(STATUS "Installation will remove old config files: ${OLD_CONFIG_FILES}")
		install(CODE "file(REMOVE ${OLD_CONFIG_FILES})")
	endif()

	install(FILES
		"${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config.cmake"
		"${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config-version.cmake"
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/zeep
		COMPONENT Devel
	)

	set(zeep_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
	set_target_properties(zeep PROPERTIES
		VERSION ${PROJECT_VERSION}
		SOVERSION ${PROJECT_VERSION_MAJOR}
		INTERFACE_zeep_MAJOR_VERSION ${PROJECT_VERSION_MAJOR}
		COMPATIBLE_INTERFACE_STRING zeep_MAJOR_VERSION
	)

	# Config file
	set(LIBZEEP_VERSION ${PROJECT_VERSION})
	set(LIBZEEP_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
	set(LIBZEEP_VERSION_MINOR ${PROJECT_VERSION_MINOR})
	set(LIBZEEP_VERSION_PATCH ${PROJECT_VERSION_PATCH})

	configure_file("${PROJECT_SOURCE_DIR}/include/zeep/config.hpp.in" "${PROJECT_SOURCE_DIR}/include/zeep/config.hpp" @ONLY)
endif(ZEEP_BUILD_LIBRARY)

# Documentation
if(ZEEP_BUILD_DOCUMENTATION)
	add_subdirectory(docs)
endif()

# Examples
if(ZEEP_BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

# Tests

=== docs/CMakeLists.txt ===
find_package(Doxygen REQUIRED)
find_package(Sphinx REQUIRED)

# Find all the public headers
# get_target_property(ZEEP_PUBLIC_HEADER_DIR libzeep INTERFACE_INCLUDE_DIRECTORIES)
set(ZEEP_PUBLIC_HEADER_DIR ${PROJECT_SOURCE_DIR}/include/zeep)
file(GLOB_RECURSE ZEEP_PUBLIC_HEADERS ${ZEEP_PUBLIC_HEADER_DIR}/*.hpp)

set(DOXYGEN_INPUT_DIR ${ZEEP_PUBLIC_HEADER_DIR})
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/xml)
set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/index.xml)
set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

#Replace variables inside @@ with the current values
configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

add_custom_command(
	OUTPUT ${DOXYGEN_OUTPUT_DIR}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${DOXYGEN_OUTPUT_DIR})

add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
				   BYPRODUCTS ${DOXYGEN_OUTPUT_DIR}
                   DEPENDS ${ZEEP_PUBLIC_HEADERS}  ${DOXYGEN_OUTPUT_DIR} ${DOXYFILE_OUT}
                   COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
                   MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
                   COMMENT "Generating docs")

add_custom_target("Doxygen-libzeep" ALL DEPENDS ${DOXYGEN_INDEX_FILE})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_SOURCE_DIR}/conf.py @ONLY)

set(SPHINX_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
set(SPHINX_BUILD ${CMAKE_CURRENT_BINARY_DIR}/sphinx)

add_custom_target("Sphinx-libzeep" ALL
                  COMMAND ${SPHINX_EXECUTABLE} -b html
				  -Dbreathe_projects.libzeep=${DOXYGEN_OUTPUT_DIR}
                  ${SPHINX_SOURCE} ${SPHINX_BUILD}
				  DEPENDS ${DOXYGEN_INDEX_FILE}
				  BYPRODUCTS ${CMAKE_CURRENT_SOURCE_DIR}/api
                  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                  COMMENT "Generating documentation with Sphinx")

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/sphinx/ DESTINATION ${CMAKE_INSTALL_DOCDIR} PATTERN .doctrees EXCLUDE)

=== docs/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile --output-file=requirements.txt requirements.in
#
alabaster==0.7.13
    # via sphinx
babel==2.12.1
    # via sphinx
beautifulsoup4==4.12.2
    # via exhale
breathe==4.35.0
    # via
    #   -r requirements.in
    #   exhale
certifi==2024.7.4
    # via requests
charset-normalizer==3.2.0
    # via requests
docutils==0.17.1
    # via
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx
    #   sphinx-rtd-theme
exhale==0.3.6
    # via -r requirements.in
idna==3.7
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.5
    # via
    #   myst-parser
    #   sphinx
lxml==4.9.3
    # via exhale
markdown-it-py==2.2.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.3
    # via jinja2
mdit-py-plugins==0.3.5
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-parser==0.18.1
    # via -r requirements.in
packaging==23.1
    # via sphinx
pygments==2.16.1
    # via sphinx
pyyaml==6.0.1
    # via myst-parser
requests==2.32.0
    # via sphinx
six==1.16.0
    # via exhale
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.4.1
    # via beautifulsoup4
sphinx==4.5.0
    # via
    #   -r requirements.in
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx-rtd-theme
    #   sphinxcontrib-jquery
sphinx-rtd-theme==1.3.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.4
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.1
    # via sphinx
sphinxcontrib-jquery==4.1
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
typing-extensions==4.7.1
    # via myst-parser
urllib3==2.2.2
    # via requests

=== examples/CMakeLists.txt ===
#           Copyright Maarten L. Hekkelman, 2022
#  Distributed under the Boost Software License, Version 1.0.
#     (See accompanying file LICENSE_1_0.txt or copy at
#           http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.16)

project(libzeep-examples LANGUAGES CXX)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Only try to find package if we're not included from the main libzeep CMakeLists.txt
get_property(PARENT_DIRECTORY DIRECTORY "${CMAKE_CURRENT_LIST_DIR}" PROPERTY PARENT_DIRECTORY)

if("${PARENT_DIRECTORY}" STREQUAL "")
	find_package(zeep REQUIRED)
endif()

list(APPEND examples http-server-0 http-server-1 http-server-2 http-server-3
	serialize-xml synopsis-json synopsis-xml validating-xml-sample xpath-sample
	synopsis-el-1 security-sample rest-sample rest-sample-2	soap-sample)

if (ZEEP_HAS_UNIX_DAEMON)
	list(APPEND examples daemon-sample)
endif()

foreach(EXAMPLE IN LISTS examples)
	add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
	target_link_libraries(${EXAMPLE} zeep::zeep)
endforeach()

=== test/CMakeLists.txt ===
# Copyright Maarten L. Hekkelman, 2025
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# For the unit tests:
find_package(Boost REQUIRED)

if(NOT (mcfp_FOUND OR TARGET mcfp))
	find_package(mcfp 1.3.5 QUIET)

	if(NOT mcfp_FOUND)
		if(ZEEP_ALLOW_FETCH_CONTENT)
			include(FetchContent)

			FetchContent_Declare(mcfp GIT_REPOSITORY https://github.com/mhekkel/libmcfp GIT_TAG v1.3.5)
			FetchContent_MakeAvailable(mcfp)
		else()
			message(FATAL_ERROR "The mcfp package was not found, please install https://github.com/mhekkel/libmcfp and try again")
		endif()
	endif()
endif()

# data files for the parser test
add_library(client_test OBJECT ${CMAKE_CURRENT_SOURCE_DIR}/http/client-test-code.cpp)

target_include_directories(client_test PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/include
	${CMAKE_CURRENT_BINARY_DIR} # for config.h
	${PROJECT_SOURCE_DIR}/include
)

if(ZEEP_USE_BOOST_ASIO)
	target_link_libraries(client_test PRIVATE Boost::boost)
endif()

# data files for the parser test
set(XML_CONF_TAR ${CMAKE_CURRENT_SOURCE_DIR}/xml/XML-Test-Suite.tbz)
set(XML_CONF_FILE ${CMAKE_CURRENT_SOURCE_DIR}/xml/XML-Test-Suite/xmlconf/xmlconf.xml)

if(NOT EXISTS ${XML_CONF_FILE})
	if(${CMAKE_VERSION} VERSION_LESS "3.18.0")
		find_program(TAR tar)

		if(TAR)
			add_custom_command(OUTPUT ${XML_CONF_FILE}
				COMMAND ${TAR} xf ${XML_CONF_TAR}
				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/xml/)
		else()
			message(FATAL_ERROR "Please extract the archive ${XML_CONF_TAR} manually or update your cmake version to at least 3.18")
		endif()
	else()
		file(ARCHIVE_EXTRACT INPUT ${XML_CONF_TAR}
			DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/xml/)
	endif()
endif()

add_custom_target(XML_CONF ALL DEPENDS ${XML_CONF_FILE})

# unit parser serializer xpath json crypto http processor webapp soap rest security uri
list(APPEND zeep_tests
	xml/unit
	xml/parser
	xml/serializer
	xml/xpath
	json/json
	http/crypto
	http/http
	http/processor
	http/webapp
	http/soap
	http/rest
	http/security
	http/uri)

if(USE_RSRC)
	list(APPEND zeep_tests http/rsrc_webapp)
endif()

foreach(TEST IN LISTS zeep_tests)
	string(REGEX MATCH "^[^/]+" ZEEP_TEST_DIR ${TEST})
	string(REGEX MATCH "[^/]+$" ZEEP_TEST ${TEST})

	set(ZEEP_TEST "${ZEEP_TEST}-test")
	set(ZEEP_TEST_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/${ZEEP_TEST_DIR}/${ZEEP_TEST}.cpp")

	add_executable(${ZEEP_TEST} ${ZEEP_TEST_SOURCE} $<TARGET_OBJECTS:client_test> ${ZEEP_TEST_RESOURCE})

	if("${TEST}" STREQUAL "http/processor")
		target_compile_definitions(${ZEEP_TEST} PUBLIC DOCROOT=".")
	endif()

	if(USE_RSRC AND("${TEST}" STREQUAL "http/processor" OR "${TEST}" STREQUAL "http/rsrc_webapp"))
		mrc_target_resources(${ZEEP_TEST} ${CMAKE_CURRENT_SOURCE_DIR}/http/fragment-file.xhtml)
	endif()

	target_include_directories(${ZEEP_TEST} PRIVATE
		${CMAKE_CURRENT_SOURCE_DIR}/include
		${CMAKE_CURRENT_BINARY_DIR} # for config.h
		${PROJECT_SOURCE_DIR}/include
		${PROJECT_SOURCE_DIR}/lib-http/src # for signals.hpp
	)

	target_link_libraries(${ZEEP_TEST} PRIVATE zeep ${STDCPPFS_LIBRARY} mcfp::mcfp)

	if(MSVC)
		# Specify unwind semantics so that MSVC knowns how to handle exceptions
		target_compile_options(${ZEEP_TEST} PRIVATE /EHsc)
	endif()

	add_custom_target("run-${ZEEP_TEST}" DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Run${ZEEP_TEST}.touch ${ZEEP_TEST})

	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${ZEEP_TEST}.touch
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${ZEEP_TEST}
	)

	if("${TEST}" STREQUAL "xml/parser")
		# Some tests should be skipped
		list(APPEND ZEEP_TEST_ARGS
			ibm-valid-P28-ibm28v02.xml ibm-valid-P29-ibm29v01.xml ibm-valid-P29-ibm29v02.xml
			ibm-1-1-valid-P03-ibm03v09.xml rmt-e2e-34 rmt-e2e-55 rmt-054 rmt-ns10-006 rmt-e3e-13)
		list(TRANSFORM ZEEP_TEST_ARGS PREPEND "--questionable=")
		list(PREPEND ZEEP_TEST_ARGS ${XML_CONF_FILE} "--print-ids")
		add_dependencies(${ZEEP_TEST} XML_CONF)
	else()
		set(ZEEP_TEST_ARGS "")
	endif()

	add_test(NAME ${ZEEP_TEST}
		COMMAND $<TARGET_FILE:${ZEEP_TEST}> ${ZEEP_TEST_ARGS}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${ZEEP_TEST_DIR})
endforeach()

=== debian/changelog ===
libzeep (6.1.1-1) experimental; urgency=medium

  * New upstream version 6.1.1
  * Added copyright statements

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 09 Feb 2025 13:07:43 +0100

libzeep (6.1.0-1) experimental; urgency=medium

  [ Andreas Tille ]
  * Fix clean target Closes: #1046447

  [ Maarten L. Hekkelman ]
  * New upstream version 6.1.0
  * remove patches

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 05 Feb 2025 11:42:39 +0100

libzeep (6.0.6-1) experimental; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.0 (routine-update)
  * Drop transition for old debug package migration.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 22 Aug 2023 09:54:23 +0200

=== debian/control ===
Source: libzeep
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>,
           Andreas Tille <tille@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
			   cmake,
			   libboost-dev,
			   libhowardhinnant-date-dev,
			   libmcfp-dev,
			   mrc,
			   doxygen,
			   python3-exhale,
               python3-sphinx-rtd-theme,
               python3-myst-parser
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/libzeep
Vcs-Git: https://salsa.debian.org/med-team/libzeep.git
Homepage: https://github.com/mhekkel/libzeep
Rules-Requires-Root: no

Package: libzeep-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libzeep6 (= ${binary:Version}),
         libboost-dev,
         libhowardhinnant-date-dev,
         cmake
Suggests: libzeep-doc, mrc
Description: Development files for libzeep
 Libzeep is a C++ library providing a validating XML parser, XML DOM tree
 implementation, XPath 1.0 support and code to create SOAP/REST servers as
 well as a full web application framework.
 .
 libzeep was originally designed to create SOAP servers in C++ easily. The
 current incarnation provides a full validating XML parser creating a DOM tree
 that can be iterated using STL container like methods. The tree can be searched
 using XPath 1.0 queries.
 .
 There's also code to create SOAP and REST servers based allowing to export
 C++ methods as web services. And there's a full web application framework to
 create dynamic web sites in C++ and XHTML.
 .
 This specific package contains all files needed to develop new
 software using libzeep.

Package: libzeep-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libzeep-dev (>= ${binary:Version})
Description: Documentation for libzeep
 Libzeep is a C++ library providing a validating XML parser, XML DOM tree
 implementation, XPath 1.0 support and code to create SOAP/REST servers as
 well as a full web application framework.
 .
 libzeep was originally designed to create SOAP servers in C++ easily. The
 current incarnation provides a full validating XML parser creating a DOM tree
 that can be iterated using STL container like methods. The tree can be searched
 using XPath 1.0 queries.
 .
 There's also code to create SOAP and REST servers based allowing to export
 C++ methods as web services. And there's a full web application framework to
 create dynamic web sites in C++ and XHTML.
 .
 This specific package contains the documentation you can use to develop new
 software using libzeep.

Package: libzeep6
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library file for libzeep
 Libzeep is a C++ library providing a validating XML parser, XML DOM tree
 implementation, XPath 1.0 support and code to create SOAP/REST servers as
 well as a full web application framework.
 .
 libzeep was originally designed to create SOAP servers in C++ easily. The
 current incarnation provides a full validating XML parser creating a DOM tree
 that can be iterated using STL container like methods. The tree can be searched
 using XPath 1.0 queries.
 .
 There's also code to create SOAP and REST servers based allowing to export
 C++ methods as web services. And there's a full web application framework to
 create dynamic web sites in C++ and XHTML.
 .
 This package contains the shared library only.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
# Fixing reproducible builds
LC_ALL := C.UTF-8
export LC_ALL

%:
	dh $@

override_dh_clean:
	dh_clean
	rm -rf doc/html

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DUSE_RSRC=ON -DZEEP_BUILD_DOCUMENTATION=ON -DBUILD_TESTING=ON

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build

=== debian/tests/control ===
Tests: run-build-test
Depends: build-essential, libzeep-dev
Restrictions: allow-stderr

## libzeep 7.3.1

=== CMakeLists.txt ===
# Copyright Maarten L. Hekkelman, 2023-2026
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.28)

project(libzeep VERSION 7.3.1 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(CMakePackageConfigHelpers)
include(CPM)
include(CTest)
include(VersionString)

option(ZEEP_BUILD_DOCUMENTATION "Build documentation" OFF)
option(ZEEP_USE_BOOST_ASIO "Use the asio library from Boost instead of the non-boost version" ON)
option(ZEEP_BUILD_EXAMPLES "Build the example applications" ON)

# New policy for Boost, set it here
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.30)
    cmake_policy(SET CMP0167 NEW)
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
elseif(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

if(WIN32)
    # Windows specific stuff
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

    if(${CMAKE_SYSTEM_VERSION} GREATER_EQUAL 10) # Windows 10
        add_definitions(-D _WIN32_WINNT=0x0A00)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
        add_definitions(-D _WIN32_WINNT=0x0603)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
        add_definitions(-D _WIN32_WINNT=0x0602)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
        add_definitions(-D _WIN32_WINNT=0x0601)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
        add_definitions(-D _WIN32_WINNT=0x0600)
    else() # Windows XP (5.1)
        add_definitions(-D _WIN32_WINNT=0x0501)
    endif()

    add_definitions(-DNOMINMAX)
endif()

if(MSVC)
    # make msvc standards compliant...
    add_compile_options(/permissive-)
endif()

# Optionally use mrc to create resources
if(WIN32 AND BUILD_SHARED_LIBS)
    message(STATUS "zeep: Not using resources when building shared libraries for Windows")
else()
    find_package(mrc QUIET)

    if(MRC_FOUND)
        option(USE_RSRC "Use mrc to create resources" ON)

        if(USE_RSRC)
            message(STATUS "zeep: Using resources compiled with ${MRC_EXECUTABLE} version ${MRC_VERSION_STRING}")
            set(WEBAPP_USES_RESOURCES 1)
        endif()
    else()
        message(STATUS "zeep: Not using resources since mrc was not found")
    endif()
endif()

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

if(ZEEP_USE_BOOST_ASIO)
    find_package(Boost 1.74 REQUIRED COMPONENTS headers)

    message(STATUS "zeep: Using asio from boost")

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/asio-boost.hpp.in ${CMAKE_CURRENT_SOURCE_DIR}/include/zeep/http/asio.hpp @ONLY)

    set(FIND_DEPENDENCY_BOOST "find_dependency(Boost REQUIRED)")
else()
    find_path(ASIO_INCLUDE_DIR asio.hpp)

    if(ASIO_INCLUDE_DIR STREQUAL "ASIO_INCLUDE_DIR-NOTFOUND")
        CPMAddPackage(
            NAME asio
            URL https://github.com/chriskohlhoff/asio/archive/refs/tags/asio-1-36-0.tar.gz)

        set(ASIO_INCLUDE_DIR ${asio_SOURCE_DIR}/asio/include)
    endif()

    message(STATUS "zeep: Using asio from ${ASIO_INCLUDE_DIR}")

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/asio.hpp.in ${CMAKE_CURRENT_SOURCE_DIR}/include/zeep/http/asio.hpp @ONLY)
endif()

try_run(TEST_STD_CHRONO_ZONED_TIME_R TEST_STD_CHRONO_ZONED_TIME_C
    SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/test-chrono-zoned_time.cpp
    CXX_STANDARD 20)

if("${TEST_STD_CHRONO_ZONED_TIME_R}" EQUAL "0")
    set(USE_STD_CHRONO_ZONED_TIME TRUE)
else()
    set(USE_STD_CHRONO_ZONED_TIME FALSE)
endif()

if(NOT USE_STD_CHRONO_ZONED_TIME)
    message(NOTICE "zeep: Using Howard Hinnants date for from_stream")
    CPMFindPackage(
        NAME date
        GIT_REPOSITORY "https://github.com/HowardHinnant/date"
        VERSION 3.0.3
        EXCLUDE_FROM_ALL YES
        OPTIONS
        "USE_SYSTEM_TZ_DB ON"
        "BUILD_TZ_LIB ON")
    add_compile_definitions(USE_DATE_H)
endif()

CPMFindPackage(NAME zeem
    GIT_REPOSITORY "https://github.com/mhekkel/zeem.git"
    VERSION 2.1.1
    EXCLUDE_FROM_ALL YES)

if(UNIX)
    find_file(HAVE_SYS_WAIT_H "sys/wait.h")

    if(HAVE_SYS_WAIT_H)
        set(HTTP_SERVER_HAS_PREFORK 1)
    endif()

    find_file(HAVE_UNISTD_H "unistd.h")

    if(HAVE_UNISTD_H)
        set(HTTP_HAS_UNIX_DAEMON 1)
    endif()
endif()

# Generate the revision.hpp file
write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src" LIB_NAME "libzeep")

# Library rules
file(GLOB_RECURSE zeep_cpp src/*.cpp)
file(GLOB_RECURSE zeep_hpp include/*.hpp)

# TODO: SOAP is not working at the moment, really need to fix that
list(FILTER zeep_cpp EXCLUDE REGEX src/soap-controller.cpp)

if(NOT USE_RSRC)
    list(FILTER zeep_cpp EXCLUDE REGEX src/controller-rsrc.cpp)
endif()

if(NOT HTTP_SERVER_HAS_PREFORK)
    list(FILTER zeep_hpp EXCLUDE REGEX zeep/http/preforked-server.hpp)
    list(FILTER zeep_cpp EXCLUDE REGEX src/preforked-server.cpp)
endif()

add_library(zeep ${zeep_cpp})
add_library(zeep::zeep ALIAS zeep)

target_sources(zeep
    PUBLIC FILE_SET zeep_headers TYPE HEADERS
    BASE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include
    FILES ${zeep_hpp})

set_target_properties(zeep PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(zeep PUBLIC cxx_std_20)
target_include_directories(zeep PUBLIC "$<BUILD_INTERFACE:${ASIO_INCLUDE_DIR}>")
target_link_libraries(zeep PUBLIC Threads::Threads zeem::zeem)

if(NOT USE_STD_CHRONO_ZONED_TIME)
    target_link_libraries(zeep PUBLIC date::date-tz)
endif()

if(ZEEP_USE_BOOST_ASIO)
    target_link_libraries(zeep PUBLIC Boost::headers)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    target_link_options(zeep PRIVATE -undefined dynamic_lookup)
endif()

# Install rules
install(TARGETS zeep
    EXPORT zeep-targets
    FILE_SET zeep_headers
    DESTINATION include)

install(EXPORT zeep-targets
    NAMESPACE zeep::
    DESTINATION lib/cmake/zeep)

configure_package_config_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/zeep-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config.cmake
    INSTALL_DESTINATION lib/cmake/zeep)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config-version.cmake"
    COMPATIBILITY AnyNewerVersion)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/zeep/zeep-config-version.cmake"
    DESTINATION lib/cmake/zeep
    COMPONENT Devel)

set(zeep_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
set_target_properties(zeep PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
    INTERFACE_zeep_MAJOR_VERSION ${PROJECT_VERSION_MAJOR}
    COMPATIBLE_INTERFACE_STRING zeep_MAJOR_VERSION)

# Config file
set(LIBZEEP_VERSION ${PROJECT_VERSION})
set(LIBZEEP_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(LIBZEEP_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(LIBZEEP_VERSION_PATCH ${PROJECT_VERSION_PATCH})

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/include/zeep/config.hpp.in" "${CMAKE_CURRENT_SOURCE_DIR}/include/zeep/config.hpp" @ONLY)

# Documentation
if(ZEEP_BUILD_DOCUMENTATION)
    add_subdirectory(docs)
endif()

# Examples
if(ZEEP_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

# Test applications, but only if we're not included as a subproject
if(BUILD_TESTING AND PROJECT_IS_TOP_LEVEL)
    add_subdirectory(test)
endif()

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#           Copyright Maarten L. Hekkelman, 2022
+#         Copyright Maarten L. Hekkelman, 2022-2026
 #  Distributed under the Boost Software License, Version 1.0.
 #     (See accompanying file LICENSE_1_0.txt or copy at
 #           http://www.boost.org/LICENSE_1_0.txt)
@@ -19,14 +19,14 @@
 endif()
 
 list(APPEND examples http-server-0 http-server-1 http-server-2 http-server-3
-	serialize-xml synopsis-json synopsis-xml validating-xml-sample xpath-sample
-	synopsis-el-1 security-sample rest-sample rest-sample-2	soap-sample)
+	security-sample rest-sample rest-sample-2 # soap-sample
+	)
 
 if (ZEEP_HAS_UNIX_DAEMON)
 	list(APPEND examples daemon-sample)
 endif()
 
 foreach(EXAMPLE IN LISTS examples)
-	add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
+	add_executable(${EXAMPLE} ${CMAKE_CURRENT_SOURCE_DIR}/${EXAMPLE}.cpp)
 	target_link_libraries(${EXAMPLE} zeep::zeep)
 endforeach()

=== debian/changelog ===
libzeep (7.3.1-1) unstable; urgency=medium

  [ Maarten L. Hekkelman ]
  * New upstream version 7.3.1
    Closes: #1127227

  [ Andreas Tille ]
  * d/watch: version=5
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Sun, 22 Feb 2026 11:27:07 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,23 @@
 Source: libzeep
+Standards-Version: 4.7.3
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>,
-           Andreas Tille <tille@debian.org>
+Uploaders:
+ Maarten L. Hekkelman <maarten@hekkelman.com>,
+ Andreas Tille <tille@debian.org>,
 Section: libs
-Priority: optional
-Build-Depends: debhelper-compat (= 13),
-			   cmake,
-			   libboost-dev,
-			   libhowardhinnant-date-dev,
-			   libmcfp-dev,
-			   mrc,
-			   doxygen,
-			   python3-exhale,
-               python3-sphinx-rtd-theme,
-               python3-myst-parser
-Standards-Version: 4.7.0
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ libzeem-dev,
+ libboost-dev,
+ libhowardhinnant-date-dev,
+ libmcfp-dev,
+ catch2,
+ mrc,
+ doxygen,
+ python3-exhale,
+ python3-sphinx-rtd-theme,
+ python3-myst-parser,
 Vcs-Browser: https://salsa.debian.org/med-team/libzeep
 Vcs-Git: https://salsa.debian.org/med-team/libzeep.git
 Homepage: https://github.com/mhekkel/libzeep
@@ -23,12 +26,16 @@
 Package: libzeep-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends},
-         libzeep6 (= ${binary:Version}),
-         libboost-dev,
-         libhowardhinnant-date-dev,
-         cmake
-Suggests: libzeep-doc, mrc
+Depends:
+ ${misc:Depends},
+ libzeep7 (= ${binary:Version}),
+ libzeem-dev,
+ libboost-dev,
+ libhowardhinnant-date-dev,
+ cmake,
+Suggests:
+ libzeep-doc,
+ mrc,
 Description: Development files for libzeep
  Libzeep is a C++ library providing a validating XML parser, XML DOM tree
  implementation, XPath 1.0 support and code to create SOAP/REST servers as
@@ -50,8 +57,10 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends}
-Suggests: libzeep-dev (>= ${binary:Version})
+Depends:
+ ${misc:Depends},
+Suggests:
+ libzeep-dev (>= ${binary:Version}),
 Description: Documentation for libzeep
  Libzeep is a C++ library providing a validating XML parser, XML DOM tree
  implementation, XPath 1.0 support and code to create SOAP/REST servers as
@@ -69,10 +78,11 @@
  This specific package contains the documentation you can use to develop new
  software using libzeep.
 
-Package: libzeep6
+Package: libzeep7
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Library file for libzeep
  Libzeep is a C++ library providing a validating XML parser, XML DOM tree
  implementation, XPath 1.0 support and code to create SOAP/REST servers as

## libzeep 7.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 cmake_minimum_required(VERSION 3.28)
 
-project(libzeep VERSION 7.3.1 LANGUAGES CXX)
+project(libzeep VERSION 7.3.2 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
@@ -149,6 +149,7 @@
 # Library rules
 file(GLOB_RECURSE zeep_cpp src/*.cpp)
 file(GLOB_RECURSE zeep_hpp include/*.hpp)
+list(APPEND zeep_hpp include/zeep/config.hpp)
 
 # TODO: SOAP is not working at the moment, really need to fix that
 list(FILTER zeep_cpp EXCLUDE REGEX src/soap-controller.cpp)

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,9 @@
+cmake_minimum_required(VERSION 3.28)
+
+project(zeep-docs)
+
+list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
+
 find_package(Doxygen REQUIRED)
 find_package(Sphinx REQUIRED)
 
@@ -20,7 +26,7 @@
     COMMAND ${CMAKE_COMMAND} -E make_directory ${DOXYGEN_OUTPUT_DIR})
 
 add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
-				   BYPRODUCTS ${DOXYGEN_OUTPUT_DIR}
+				#    BYPRODUCTS ${DOXYGEN_OUTPUT_DIR}
                    DEPENDS ${ZEEP_PUBLIC_HEADERS}  ${DOXYGEN_OUTPUT_DIR} ${DOXYFILE_OUT}
                    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
                    MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
@@ -42,4 +48,4 @@
                   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                   COMMENT "Generating documentation with Sphinx")
 
-install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/sphinx/ DESTINATION ${CMAKE_INSTALL_DOCDIR} PATTERN .doctrees EXCLUDE)
+install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/sphinx/ DESTINATION share/doc/libzeep PATTERN .doctrees EXCLUDE)

=== docs/requirements.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
     # via requests
 imagesize==1.4.1
     # via sphinx
-jinja2==3.1.5
+jinja2==3.1.6
     # via
     #   myst-parser
     #   sphinx
@@ -55,7 +55,7 @@
     # via sphinx
 pyyaml==6.0.1
     # via myst-parser
-requests==2.32.0
+requests==2.32.4
     # via sphinx
 six==1.16.0
     # via exhale
@@ -89,5 +89,5 @@
     # via sphinx
 typing-extensions==4.7.1
     # via myst-parser
-urllib3==2.2.2
+urllib3==2.6.3
     # via requests

=== examples/CMakeLists.txt ===
#         Copyright Maarten L. Hekkelman, 2022-2026
#  Distributed under the Boost Software License, Version 1.0.
#     (See accompanying file LICENSE_1_0.txt or copy at
#           http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.16)

project(libzeep-examples LANGUAGES CXX)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Only try to find package if we're not included from the main libzeep CMakeLists.txt
if(PROJECT_IS_TOP_LEVEL)
    find_package(zeep REQUIRED)
endif()

if(UNIX)
    find_file(HAVE_UNISTD_H "unistd.h")

    if(HAVE_UNISTD_H)
        set(HTTP_HAS_UNIX_DAEMON 1)
    endif()
endif()

list(APPEND examples http-server-0 http-server-1 http-server-2 http-server-3
    security-sample rest-sample rest-sample-2 # soap-sample
)

if(HTTP_HAS_UNIX_DAEMON)
    list(APPEND examples daemon-sample)
endif()

foreach(EXAMPLE IN LISTS examples)
    add_executable(${EXAMPLE} ${CMAKE_CURRENT_SOURCE_DIR}/${EXAMPLE}.cpp)
    target_link_libraries(${EXAMPLE} zeep::zeep)
endforeach()

=== test/CMakeLists.txt ===
# Copyright Maarten L. Hekkelman 2025
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

CPMFindPackage(
	NAME Catch2
	GIT_REPOSITORY "https://github.com/catchorg/Catch2"
	VERSION 3.4.0
	EXCLUDE_FROM_ALL YES)
CPMFindPackage(
	NAME mcfp
	GIT_REPOSITORY "https://forge.hekkelman.net/maarten/mcfp.git"
	VERSION 1.4.2
	EXCLUDE_FROM_ALL YES)

# unit parser serializer xpath json crypto http processor webapp soap rest security uri
list(APPEND zeep_tests
	crypto
	el
	http
	processor
	webapp
	# soap
	rest
	security
	uri
)

if(HTTP_HAS_UNIX_DAEMON)
	list(APPEND zeep_tests daemon)
endif()

if(USE_RSRC)
	list(APPEND zeep_tests rsrc_webapp)
endif()

add_library(zeep-test-lib OBJECT
	${CMAKE_CURRENT_SOURCE_DIR}/test-main.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/client-test-code.cpp
)
target_link_libraries(zeep-test-lib zeep mcfp::mcfp Catch2::Catch2)

foreach(TEST IN LISTS zeep_tests)
	set(ZEEP_TEST "${TEST}-test")
	set(ZEEP_TEST_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/${ZEEP_TEST}.cpp")

	add_executable(${ZEEP_TEST})
	target_sources(${ZEEP_TEST} PRIVATE ${ZEEP_TEST_SOURCE})
	
	if(USE_RSRC AND("${TEST}" STREQUAL "processor" OR "${TEST}" STREQUAL "rsrc_webapp"))
		mrc_target_resources(${ZEEP_TEST} ${CMAKE_CURRENT_SOURCE_DIR}/fragment-file.xhtml)
	endif()

	target_link_libraries(${ZEEP_TEST} PRIVATE zeep-test-lib)

	if(MSVC)
		# Specify unwind semantics so that MSVC knowns how to handle exceptions
		target_compile_options(${ZEEP_TEST} PRIVATE /EHsc)
	endif()

	add_test(NAME ${ZEEP_TEST}
		COMMAND $<TARGET_FILE:${ZEEP_TEST}> --docroot ${CMAKE_CURRENT_SOURCE_DIR})
endforeach()

=== debian/changelog ===
libzeep (7.3.2-3) unstable; urgency=medium

  * Disable daemon-test, since it does not work as expected.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 27 Feb 2026 09:42:40 +0100

libzeep (7.3.2-2) unstable; urgency=medium

  * Fixes daemon-test, use unique directory for storing PID file.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 26 Feb 2026 14:31:25 +0100

libzeep (7.3.2-1) unstable; urgency=medium

  [ Maarten L. Hekkelman ]
  * New upstream version 7.3.2
  * Fixes autopkgtest

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 26 Feb 2026 11:57:39 +0100

=== debian/control ===
--- 
+++ 
@@ -59,6 +59,8 @@
 Section: doc
 Depends:
  ${misc:Depends},
+ libjs-jquery,
+ libjs-sphinxdoc
 Suggests:
  libzeep-dev (>= ${binary:Version}),
 Description: Documentation for libzeep

=== debian/tests/control ===
Tests: run-build-test
Depends: build-essential, libzeep-dev, curl
Restrictions: allow-stderr
